Attribute VB_Name = "IniModule"
Option Explicit

Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

'   // Get IniFileInfo
Public Function ProfileGetItem(SName As String, KName As String, dValue As String, inifile As String) As String
Dim a As Long
Dim nSize As Integer
Dim ret As String

    ret = Space(2048)
    nSize = Len(ret)
    a = GetPrivateProfileString(SName, KName, dValue, ret, nSize, inifile)
    
    If a <> 0 Then
       ProfileGetItem = Left$(ret, a)
    Else
       ProfileGetItem = dValue
    End If
    
End Function

' HTƬ@,[Wp thousand , million , billion
Public Function TransEngStr(Eng_Str As String, Unit_Loc As Integer) As String
Dim UnitA
Dim NumA
Dim NumB
Dim EngStr As String
Dim I, J, K As Integer
UnitA = Array("", " THOUSAND", " MILLION", " BILLION")
NumA = Array("", " ONE", " TWO", " THREE", " FOUR", " FIVE", " SIX", " SEVEN", " EIGHT", " NIGHT", " TEN", " ELEVEN", " TWELVE", " THIRTEEN", " FOURTEEN", " FIFTEEN", " SIXTEEN", " SVENTEEN", " EIGHTEEN", " NIGHTEEN")
NumB = Array("", "", " TWENTY", " THIRTY", " FOURTY", " FIFTY", " SIXTY", " SVENTY", " EIGHTY", " NIGHTY")
I = 0
J = 0
K = 0
EngStr = ""
' I ʦ , J  B , K  Ӧ
 If CInt(Eng_Str) > 0 Then
   If Len(Eng_Str) = 3 Then
      I = CInt(Mid(Eng_Str, 1, 1))
      EngStr = NumA(CInt(I)) & " HUNDRED"
      
      'ݬO_ 1 ~ 19 
      If CInt(Mid(Eng_Str, 2, 2)) >= 20 Then
         J = CInt(Mid(Eng_Str, 2, 1))
         'B
         If J > 0 Then
            EngStr = EngStr & NumB(J)
         End If
         K = CInt(Mid(Eng_Str, 3, 1))
         'Ӧ
         If K > 0 Then
            EngStr = EngStr & NumA(K)
         End If
      Else
         J = CInt(Mid(Eng_Str, 2, 2))
         EngStr = EngStr & NumA(J)
      End If
   Else
       If Len(Eng_Str) = 2 Then
          If CInt(Eng_Str) >= 20 Then
             J = CInt(Mid(Eng_Str, 1, 1))
             K = CInt(Mid(Eng_Str, 2, 1))
             'B
             If J > 0 Then
                EngStr = NumB(CInt(J))
             End If
             'Ӧ
             If K > 0 Then
                EngStr = EngStr & NumA(CInt(K))
             End If
          Else
             ' 1 ~ 19 
             EngStr = NumA(CInt(Eng_Str))
          End If
       Else
          'uӦ
          EngStr = NumA(CInt(Eng_Str))
       End If
   End If
   
   If EngStr <> "" Then
      TransEngStr = EngStr & UnitA(Unit_Loc)
   End If
 Else
   TransEngStr = ""
 End If
End Function

'   //  Ʀrतjg
Public Function CMoneyFormat(iMoney As Double) As String
Dim aryMoneys()
Dim aryMValue()
Dim I As Integer
Dim S As String
Dim SM As String
Dim Str As String


    aryMoneys = Array("", "B", "", "a", "U", "B", "", "a", "", "B", "", "a", "")
    aryMValue = Array("s", "", "L", "", "v", "", "", "m", "", "h")
    
    SM = ""
    S = CStr(iMoney)
    If Len(S) > 13 Then
        Exit Function
    Else
        For I = 1 To Len(S)
            If InStr("0123456789", Mid(S, I, 1)) = 0 Then
                Exit Function
            End If
        Next I
        
        Str = " "
        For I = 0 To Len(S) - 1
            If Mid(S, Len(S) - I, 1) = 0 Then
                SM = SM + Str
            Else
                SM = aryMValue(CInt(Mid(S, Len(S) - I, 1))) + Str + aryMoneys(I) + Str + SM
            End If
        Next I
    End If
    
    CMoneyFormat = LTrim(SM) & ""
End Function


Public Function EMoneyFormat(Numstr As Double) As String
Dim TempStr As String
Dim NewStr As String
Numstr = CDec(Numstr)
    
    If Numstr = 0 Then
        EMoneyFormat = "ZERO "
        Exit Function
    End If
    
    If Numstr > 10 ^ 24 Then
        EMoneyFormat = "ഫƦrLjALkഫI"
        Exit Function
    End If
    
    If Numstr >= 10 ^ 12 Then
        NewStr = EMoneyFormat(Int(Numstr / 10 ^ 12))
        Numstr = ((Numstr / 10 ^ 12) - _
        Int(Numstr / 10 ^ 12)) * 10 ^ 12
        If Numstr = 0 Then
            TempStr = TempStr & NewStr & "BILLION "
        Else
            TempStr = TempStr & NewStr & "BILLION, "
        End If
    End If
    
    If Numstr >= 10 ^ 6 Then
        NewStr = EMoneyFormat(Int(Numstr / 10 ^ 6))
        Numstr = ((Numstr / 10 ^ 6) - _
        Int(Numstr / 10 ^ 6)) * 10 ^ 6
        If Numstr = 0 Then
            TempStr = TempStr & NewStr & "MILLION "
        Else
            TempStr = TempStr & NewStr & "MILLION, "
        End If
    End If
    
    If Numstr >= 10 ^ 3 Then
        NewStr = EMoneyFormat(Int(Numstr / 10 ^ 3))
        Numstr = ((Numstr / 10 ^ 3) - _
        Int(Numstr / 10 ^ 3)) * 10 ^ 3
        If Numstr = 0 Then
            TempStr = TempStr & NewStr & "THOUSAND "
        Else
            TempStr = TempStr & NewStr & "THOUSAND, "
        End If
    End If
    
    If Numstr >= 10 ^ 2 Then
        NewStr = EMoneyFormat(Int(Numstr / 10 ^ 2))
        Numstr = ((Numstr / 10 ^ 2) - _
        Int(Numstr / 10 ^ 2)) * 10 ^ 2
        If Numstr = 0 Then
            TempStr = TempStr & NewStr & "HUNDRED "
        Else
            TempStr = TempStr & NewStr & "HUNDRED AND "
        End If
    End If
    
    If Numstr >= 20 Then
        Select Case Int(Numstr / 10)
            Case 2
                TempStr = TempStr & "TWENTY "
            Case 3
                TempStr = TempStr & "THIRTY "
            Case 4
                TempStr = TempStr & "FORTY "
            Case 5
                TempStr = TempStr & "FIFTY "
            Case 6
                TempStr = TempStr & "SIXTY "
            Case 7
                TempStr = TempStr & "SEVENTY "
            Case 8
                TempStr = TempStr & "EIGHTY "
            Case 9
                TempStr = TempStr & "NINETY "
        End Select
        Numstr = ((Numstr / 10) - Int(Numstr / 10)) * 10
    End If
    
    If Numstr > 0 Then
        Select Case Numstr
          Case 1
              TempStr = TempStr & "ONE "
          Case 2
              TempStr = TempStr & "TWO "
          Case 3
              TempStr = TempStr & "THREE "
          Case 4
              TempStr = TempStr & "FOUR "
          Case 5
              TempStr = TempStr & "FIVE "
          Case 6
              TempStr = TempStr & "SIX "
          Case 7
              TempStr = TempStr & "SEVEN "
          Case 8
              TempStr = TempStr & "EIGHT "
          Case 9
              TempStr = TempStr & "NINE "
          Case 10
              TempStr = TempStr & "TEN "
          Case 11
              TempStr = TempStr & "ELEVEN "
          Case 12
              TempStr = TempStr & "TWELVE "
          Case 13
              TempStr = TempStr & "THIRTEEN "
          Case 14
              TempStr = TempStr & "FOURTEEN "
          Case 15
              TempStr = TempStr & "FIFTEEN "
          Case 16
              TempStr = TempStr & "SIXTEEN "
          Case 17
              TempStr = TempStr & "SEVENTEEN "
          Case 18
              TempStr = TempStr & "EIGHTEEN "
          Case 19
              TempStr = TempStr & "NINETEEN "
        End Select
        Numstr = ((Numstr / 10) - Int(Numstr / 10)) * 10
    End If
    
    EMoneyFormat = TempStr & " DOLLARS"
End Function


